dnl
dnl  Author: Antonio Carzaniga (firstname.lastname@unisi.ch)
dnl
dnl  Copyright (c) 1992-2000  University of Colorado
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to Antonio Carzaniga (firstname.lastname@unisi.ch).
dnl 

dnl  
dnl  AC_ANTO_MKPATH([ACTION-IF-NOT-FOUND][, ACTION-IF-NOT-FOUND])
dnl
dnl  check for a way to create an entire directory path 
dnl  tries `mkdir -p' and `$srcdir/mkinstalldirs'
dnl 
AC_DEFUN(AC_ANTO_MKPATH, [
  AC_CACHE_CHECK([how to create a directory path], [ac_cv_anto_mkpath], [
    anto_td=_test_anto
    # paranoia...
    while test -r $anto_td; do anto_td="$anto_td."; done
    ac_cv_anto_mkpath=no
    if mkdir -p $anto_td/1/2 > /dev/null 2>&1 && test -d $anto_td/1/2; then
      /bin/rm -rf $anto_td
      ac_cv_anto_mkpath="mkdir -p"
    elif $srcdir/mkinstalldirs $anto_td/1/2 > /dev/null 2>&1 && test -d $anto_td/1/2; then
      ac_cv_anto_mkpath=\$\(srcdir\)/mkinstalldirs
    else
      ac_cv_anto_mkpath=no
    fi])
  if test "$ac_cv_anto_mkpath" = no; then
    MKPATH=""
    : 
    $1
  else
    MKPATH="$ac_cv_anto_mkpath"
    AC_SUBST(MKPATH)
    :
    $2
  fi])
dnl
AC_DEFUN(AC_ANTO_TRY_JAVAC, [
#
# paranoia: looking for an available class/file name
#
anto_jclass=Jclass
while test -f $anto_jclass.java -o -f $anto_jclass.class; do
	anto_jclass=J$anto_jclass
done
cat > $anto_jclass.java <<EOF
	public class $anto_jclass {
		$1
        }
EOF
if test -z "$CLASSPATH"; 
then
	anto_jclass_classpath=''
else
	anto_jclass_classpath="-classpath $CLASSPATH"
fi
if AC_TRY_COMMAND($JAVAC $anto_jclass_classpath $anto_jclass.java) ; then 
	rm -f $anto_jclass.java $anto_jclass.class
	$2
else
	rm -f $anto_jclass.java $anto_jclass.class
	$3
fi
])
dnl
AC_DEFUN(AC_ANTO_JAVA_1_3_FEATURES, [
  AC_CACHE_CHECK([for some Java features], [ac_cv_anto_java_1_3_features], [
AC_ANTO_TRY_JAVAC([
    public java.util.TreeMap x = new java.util.TreeMap();
    public java.net.Socket s;
    void testing() throws java.io.IOException {
        java.net.Socket s = new java.net.Socket("localhost",1234);
        s.shutdownOutput();
        s.shutdownInput();
    }
], [
       ac_cv_anto_java_1_3_features=yes
], [
       ac_cv_anto_java_1_3_features=no
])])
   test "$ac_cv_anto_java_1_3_features" = no && AC_MSG_ERROR([
The Java compiler $JAVAC failed. (see config.log)
You need JDK version 1.3 or greater to compile and run Siena])])
dnl
AC_DEFUN(AC_ANTO_JSSE, [
AC_CACHE_CHECK([for JSSE (ssl) library], [ac_cv_anto_jsse], [
AC_ANTO_TRY_JAVAC([	
    javax.net.ssl.SSLSocket X;
    javax.net.ServerSocketFactory Y;
    javax.net.ssl.SSLServerSocket Z;
    javax.net.ssl.SSLServerSocketFactory W;
], [
    ac_cv_anto_jsse=yes
], [
    ac_cv_anto_jsse=no
])])
   test "$ac_cv_anto_jsse" = no && AC_MSG_ERROR([
Could not find the necessary JSSE classes. (see config.log)
If you are using JDK 1.3.x or older, make sure you have 
JSSE correctly installed on your system.
You may also use JDK 1.4 which features JSSE as a core component.])])
