//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.inf.unisi.ch/carzaniga/siena/
//
//  Author: Antonio Carzaniga (firstname.lastname@unisi.ch)
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 1998-2002 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to Antonio Carzaniga (firstname.lastname@unisi.ch).
//
package sienatest;

import siena.comm.*;
import java.io.FileOutputStream;

public class Receiver {

    public static void main(String[] args) {
	try {
	    if (args.length < 1) {
		System.out.println("usage: Receiver <pkt-receiver>");
		System.exit(2);
	    }

	    PacketReceiver r = ReceiverFactory.createReceiver(args[0]);

	    int res;
	    byte[] buf = new byte[65536];
	    while((res = r.receive(buf)) >= 0) {
		String s = new String(buf, 0, res);
		if (s.equals("---FINE---")) {
		    r.shutdown();
		    Thread.sleep(500);
		    System.exit(0);
		}
		System.out.println(s);
	    }
	} catch (PacketReceiverClosed ex) {
	} catch (Exception ex) {
	    System.out.println("exception: " + ex);
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
}
