//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.inf.unisi.ch/carzaniga/siena/
//
//  Author: Antonio Carzaniga (firstname.lastname@unisi.ch)
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 1998-2002 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to Antonio Carzaniga (firstname.lastname@unisi.ch).
//

//
//  this test must be withing package siena because Tokenizer is
//  private
//
package siena;

public class TestTokenizer {

    public static void main(String[] args) {
	try {
	    int res;
	    SENPBuffer t = new SENPBuffer();

	    while ((res = System.in.read(t.buf, 0, SENP.MaxPacketLen)) > 0) {
		t.init(res);
		int type;
		while((type = t.nextToken()) != SENPPacket.T_EOF) {
		    switch(type) {
		    case SENPPacket.T_INT:
			System.out.println("int: " + Long.toString(t.ival));
			break;
		    case SENPPacket.T_DOUBLE:
			System.out.println("double: "+Double.toString(t.dval));
			break;
		    case SENPPacket.T_STR:
			System.out.println("str: " + t.sval_string());
			break;
		    case SENPPacket.T_ID:
			System.out.println("id: " + t.sval_string());
			break;
		    case SENPPacket.T_BOOL:
			System.out.println("bool: " + t.bval);
			break;
		    case SENPPacket.T_OP:
			System.out.println("op: " + new String(SENP.operators[t.oval]));
			break;
		    case SENPPacket.T_LPAREN:
			System.out.println("{");
			break;
		    case SENPPacket.T_RPAREN:
			System.out.println("}");
			break;
		    case SENPPacket.T_UNKNOWN:
			System.out.println("unknown");
			break;
		    } 
		}
	    }
	} catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
}
